; 15-1994 extender Variant 2, Version 3
;
; This extender is a combination of code from Nicola's 15-1994 extender and
; one of my 15-1994 extenders.
;
; Its primary intended value is as an example and a starting point for
; writing other extenders.
;
; Use my S3C8ASM program to build it as follows:
; S3C8ASM 1994EX2.ASM -A1994EX2.HEX -L1994EX2.LST
;
; Examine the .LST file to make sure everything fits (the extender must fit in
; RAM from 8000-80FE inclusive).  Examine the .HEX file to see where the extender
; starts (somewhere at or above 701) and adjust the RDF file to end learned codes
; one byte before that (so you won't accidently destroy the extender when adding
; a learned code via IR.EXE).
;
; Read the associate read.me file for operational and installation instructions.
;
; The numbered comments in the code, like ;1; refer to more detailed explanations
; at the bottom of this file.

;1;  Signature
	xorg	2
	org	2
	db	52, 53, 4C, 36, 52, 53, 58, 30

;2;  Advanced code and macro area
	xorg	1B
	org	1B

	;Advanced code to load extender
	db	90	;Shifted record button
	db	C2	;C->2*(dev index 6 = P&P) ;2->body length
	dw	1708	;1->Protocol>0xFF ;708->Device=1800

	;Define the device buttons
	AUX1=25
	AUX2=26
	VCR=0A
	TV=01
	PnP=27
	_CD=11		; _ used because "CD" is a hex number.
	CBL=09

	;3;  Define initial macros to make the device keys work
	db	AUX1, 11, AUX1	;4;
	db	AUX2, 11, AUX2
	db	VCR, 11 VCR
	db	TV, 11, TV
	db	PnP, 11, PnP
	db	_CD, 11, _CD
	db	CBL, 11, CBL

	db	0	;Mark end of adv codes

;5; Upgrade area
	xorg	100
	org	100
	dw	dev_table
	dw	protocol_table

tv_1800:
	db	80	;Protocol = 0x180
	db	0	;No digit map
	db	1	;No defined keys
	
Protocol_180:
	db	00,00,01
	CLR	RD9		;Init stack pointer
	CALL	053E		;Flash LED 4 times
	LDW	RCA, ee_main	;Address of extender in eeprom
	NOP		    	;6; Filler to align return with L00
	NOP
	NOP
	CALL	1261		;Read 255 bytes from eeprom to ram
	; The return will be to L00 in the extender

dev_table:
	dw	1		;Number of devices
	dw	1F08		;Type=TV, Protocol>255, setup code = 0x708 = 1800
	dw	tv_1800

protocol_table:
	dw	1		;Number of protocols
	dw	180		;ID
	dw	Protocol_180

;Extender
	org	8000
	xorg	ee_main		;7;

L20:	CLR	R7D		;Interrupt flags
	CALL	$1346		;Start timer0
L30:	IDLE
	RL	R7D		;Test interrupt flags
	JREQ	L30		;No interrupt flags set
	DI
	JRC	L50		;Keyboard interrupt flag set
	CALL	$027B		;?Process timeout
	JRC	L20
L00:	TM	R7C,#$80	;BackLight on?
	JREQ	L10		;No
	LD	R4A,#$E4
	CALL	$1346		;Start timer0
L10:	CALL	$0FFB		;Wait for no keys pressed
	DI
	LD	RF1,#$7F	;Enable button sense interrupts
	CLR	RF2		;Clear pending interrupts (buttons)
	CALL	$024D		;Select timeout value
	JRC	L20		;Timeout needed

L40: ;8;CALL	$0560		;Turn on P2.4 ??
     ;9;CLR	RD9		;Init stack pointer
	EI
	LD	RFB,#$A5	;Enable stop
	STOP
	NOP
	NOP
	TM	R7D,#$80	;Button interrupt occurred?
	JREQ	L40
L50:	CALL	$0F88		;Keypad scan
	CP	R7A,#$01	;Exactly one key pressed?
	JRNE	L00		;No
	LD	W1,R77		;Key code
 	CP	R77,#$02	;SETUP?
	JRNE	L60		;No	
	LD	R4C,#$80	;Yes: set shift flag
__L0:	CALL	$04FB		;Flash LED
__L00:	JR	L00

; At this point key processing (with the key code in both R77 and W1) joins
; together with macro processing (which has the code just in W1).

L60:	CP	RC1,#$7E	;PushDev?
	JRNE	L70		;No
	LD	RB8,R5F		;10;Yes: Save Dev index
	JR	next

L70:	;11;			;PopDev? (7F)
	JRLT	L80		;No
	LD	R5F,RB8		;10;Yes: Restore Dev index
	JR	next

L80:	LD	R79, W1		;Key code
	SUB	RC1,#$77
	JRLT	L90		;12;Branch if not V_ codes	
	LD	R5C,W1		;Set V_ index
	JR	next

L90:	OR	R79,R4C		;Shift the key if flag is set
    ;13;CLR	R4C		;Clear shift flag
	CP	R79,#$20	;LIGHT key?
	JRNE	L100		;No
	CALL	$054E		;Turn light off.
	XOR	R7C,#$01	;Toggle light enable
L100:	TM	R7C,#$01	;Is light enabled?
	JREQ	L110		;No
	CALL	$0555		;Turn light on
L110:	TM	R00,#$20	;14; In a macro?
	JREQ	L120		;No
	CALL	$0E4F		;Check device keys
	JRNC	L120		;Not a device key
	LD	R5F,R7B		;Set dev index
	JR	L130		; and don't look for other meanings
	
L120:	PUSH	R5F		;15;Save normal device index
	CALL	0E43		;Vol+, Vol-, or MUTE?
	JRNC	L125		;No
	LD	R5F, R5C	;Yes: Use V_ index instead of normal device index
L125:	CALL	RomCaller
	POP	R5F		;Restore normal device index
next:	TM	R00,#$20	;In a macro?
	JREQ	__L00		;No
L130:	LD	W0,R63		;Get position in macro
	LD	W1,R65[W0]	;Get next byte of macro
	INC	R63
	CP	R63,R64		;End of macro?
	JRLE	L60		;No
	AND	R00,#$DF	;No longer in macro
	JR	__L0		;16; Flash LED, then restart

; RomCaller pushes onto the stack in reverse order a sequence of operations
; to be performed.  This method is required, rather than directly calling
; each of the routines, because the first routine may overwrite ram, so
; there would be no extender to return to if it were called directly.
;
; 17EE  Search for and load a macro or AdvCode. Nonstandard entry point
;       which allows any key to be a macro or AdvCode.  Returns with R00.4
;       set if an AdvCode was found and with C-set if either a macro or an
;       AdvCode is found.
; 033A  If C-bit is clear
;           Search for and load a learned key.  If one is found
;               Set R7C.1
;               Set C-bit
;           Else
;               Search again for a macro or AdvCode (at the standard entry
;               point) which must fail because the 17EE search already failed.
;               Clear R7C.1
;               Clear C-bit
;       (always) Clear R4C (which I use as the shift flag)
; 0327  If R7C.1 or R00.4 is set
;           Transmit the learned or Adv code that was loaded
;           Return with C-bit set
;       Else
;           Return with C-bit preserved, so it is still set if a macro was
;           found and clear otherwise.
; 02E3  If C-bit is clear search/load/xmit an ordinary (not learned, macro,
;       nor Adv) key definition.  Otherwise (C-bit set) do nothing.
; 040B  pop into RCB and RCA the eeprom address of the extender
; 1261  read 255 bytes from that eeprom address into ram
; 80xx  Continue executing the extender from where it called Romcaller
;
RomCaller:
	LDW	RRC2,#$1261	;read eeprom block
	PUSH	RC3
 	PUSH	RC2
	LDW	RRC0,ee_main	;EEPROM address of extender
	PUSH	RC0
	PUSH	RC1
	LDW	RRC2,#$040B	;pop RCB / pop RCA / ret
	PUSH	RC3
	PUSH	RC2
	LDW	RRC2,#$02E3
	PUSH	RC3
	PUSH	RC2
	LDW	RRC2,#$0327
	PUSH	RC3
	PUSH	RC2
	LD	RC3,#$3A	;$033A (RC2 already has the 03)
	PUSH	RC3
	PUSH	RC2
	JP	17EE

ee_main = ee_main + 800 - $$	;7;

; Notes referred to by number in the code above
;
;1;  Bytes 2..0A are the EEProm signature.  The EEProm signature tells IR.EXE
;    which RDF file to use.
;
;2;  The extender predefines a set of advanced codes and macros.  The installer
;    will merge those with the advanced codes and macros in the EEProm image txt
;    file.  The user can then edit them in IR.EXE.  The memory limit is applied
;    before the user gets to edit, so we don't want to go overboard and put too
;    much in here.
;
;3;  This variant of the extender enables the normal function of the device keys
;    only when inside a macro.  For convenience a install time, we predefine a
;    set of macros to give the device keys back their normal function;  However,
;    if the user didn't want to change at least some of these, then he had no
;    reason to select an extender variant that disables device key normal
;    function outside of macros.  See ;14;
;
;4;  When constructing a macro, the first byte is the key the macro is on.  The
;    second byte has 1 in its top digit and the number of functions in this
;    macro in its low byte.  The rest of the bytes are the functions in the
;    macro.  See the RDF file for hex codes for other keys or special functions.
;
;5;  Here we preinstall the protocol and device upgrade needed to load the
;    extender.
;
;6;  The entry point to the extender is at L00.  I examined the .LST file and
;    adjusted the number of NOP's here so that the return from the call to
;    1261 will land exactly on L00.
;    If that method becomes inconvenient while making a series of changes to
;    the extender, the alternate is to change the CALL to
;	LDW	RC0, L00
;       PUSH	RC1
;	PUSH	RC0
;	JP	1261
;
;7;  My assembler does multiple passes to resolve things that are unknown on
;    early passes.  I take advantage of that by forcing the assembler to guess
;    incorrectly where the protocol should start in eeprom (the undefined
;    symbol ee_main).  Then at the end of the code, ee_main is computed from
;    the assembler's incorrect guess to become whatever value puts the last
;    byte of the extender in byte 7FF.
;
;8;  Nicola's extender had that call.  I'm nearly sure it is totally
;    unecessary.  If I turn out to be wrong, my next best guess is that
;    getting this wrong reduces battery life.  It sure doesn't seem to affect
;    behavior;  But I'm nearly sure it doesn't even affect battery life,
;    because it is turning on a pin that I think is already on before the
;    extender ever has control.
;
;9;  There are reasons why you might want to init the stack pointer within
;    the main loop of an extender.  I chose to init it in the protocol instead.
;
;10; I usually use a real PUSH and POP (saving a couple bytes of code vs.
;    Nicola's version).  That requires that anyone using PushDev and PopDev in
;    macros strictly pair them.  If you get desparate for 2 more bytes and don't
;    mind the strict pairing rule, change these to "push R5F" and "pop R5F"
;
;11; I don't need another compare because 7F is the only value GT 7E
;
;12;  Since 7E and 7F are already covered, all the non V_ codes are LT the
;    VPT codes.  The SUB both converts the V_ code to an index and tests
;    whether it was a V_ code.
;
;13; Some extenders need to clear the shift flag after using it.  I don't
;    need to because all possible execution paths from here around to L00 go
;    through a ROM routine that clears R4C.
;
;14; In this variant, Device keys have their normal meaning only when inside
;    macros, and Device keys can have macros or AdvCodes on them only when
;    outside macros.  You might want Device keys outside macros to have both
;    their normal function, and a macro or AdvCode.  To allow that, change
;    those 6 instructions to these 5.
; L110:	CALL	$0E4F		;Check device keys
;	JRNC	L120		;Not a device key
;	LD	R5F,R7B		;Set dev index
;	TM	R00,#$20	;14; In a macro?
;	JRNE	L130		;Yes
;    By not checking at all here for "in macro", you could save even more bytes
;    of code and allow AdvCodes defined on device keys to function even inside
;    macros.  Macros are disabled inside macros by a different mechanism, so
;    I don't think you will run into a recursion problem.
;
;15; In this variant, I used the normal "volume punch through" index (in R5C)
;    as a V_ device index.  That means that device index is always used when
;    the vol+, vol- or mute are pressed, rather than sometimes used as the
;    VPT normally is.  If you want the ordinary VPT back, change those 6
;    instructions to just 1 instruction.
; L120: CALL RomCaller
;
;16; For this variant, the user is likely to write some macros that only change
;    the device or V_ index.  I didn't have a great way to manage the LED flash
;    for those, so I put in this kludge of an extra flash at the end of every
;    macro.  It's annoying in many macros, but without other macros would
;    execute without anything to tell you anything had happened.


